// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/ApplicationOutputs.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/application_outputs__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `evaluation_path_outputs_eval_out`
// Member `evaluation_path_outputs_is_safe`
// Member `evaluation_path_outputs_is_valid`
// Member `monitoring_case_number_outputs`
// Member `monitoring_case_number_outputs_flags`
// Member `resulting_velocity`
// Member `resulting_velocity_flags`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__init(sick_safetyscanners2_interfaces__msg__ApplicationOutputs * msg)
{
  if (!msg) {
    return false;
  }
  // evaluation_path_outputs_eval_out
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->evaluation_path_outputs_eval_out, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // evaluation_path_outputs_is_safe
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->evaluation_path_outputs_is_safe, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // evaluation_path_outputs_is_valid
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->evaluation_path_outputs_is_valid, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // monitoring_case_number_outputs
  if (!rosidl_runtime_c__uint16__Sequence__init(&msg->monitoring_case_number_outputs, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // monitoring_case_number_outputs_flags
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->monitoring_case_number_outputs_flags, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // sleep_mode_output
  // sleep_mode_output_valid
  // error_flag_contamination_warning
  // error_flag_contamination_error
  // error_flag_manipulation_error
  // error_flag_glare
  // error_flag_reference_contour_intruded
  // error_flag_critical_error
  // error_flags_are_valid
  // linear_velocity_outputs_velocity_0
  // linear_velocity_outputs_velocity_0_valid
  // linear_velocity_outputs_velocity_0_transmitted_safely
  // linear_velocity_outputs_velocity_1
  // linear_velocity_outputs_velocity_1_valid
  // linear_velocity_outputs_velocity_1_transmitted_safely
  // resulting_velocity
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->resulting_velocity, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  // resulting_velocity_flags
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->resulting_velocity_flags, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
    return false;
  }
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(sick_safetyscanners2_interfaces__msg__ApplicationOutputs * msg)
{
  if (!msg) {
    return;
  }
  // evaluation_path_outputs_eval_out
  rosidl_runtime_c__boolean__Sequence__fini(&msg->evaluation_path_outputs_eval_out);
  // evaluation_path_outputs_is_safe
  rosidl_runtime_c__boolean__Sequence__fini(&msg->evaluation_path_outputs_is_safe);
  // evaluation_path_outputs_is_valid
  rosidl_runtime_c__boolean__Sequence__fini(&msg->evaluation_path_outputs_is_valid);
  // monitoring_case_number_outputs
  rosidl_runtime_c__uint16__Sequence__fini(&msg->monitoring_case_number_outputs);
  // monitoring_case_number_outputs_flags
  rosidl_runtime_c__boolean__Sequence__fini(&msg->monitoring_case_number_outputs_flags);
  // sleep_mode_output
  // sleep_mode_output_valid
  // error_flag_contamination_warning
  // error_flag_contamination_error
  // error_flag_manipulation_error
  // error_flag_glare
  // error_flag_reference_contour_intruded
  // error_flag_critical_error
  // error_flags_are_valid
  // linear_velocity_outputs_velocity_0
  // linear_velocity_outputs_velocity_0_valid
  // linear_velocity_outputs_velocity_0_transmitted_safely
  // linear_velocity_outputs_velocity_1
  // linear_velocity_outputs_velocity_1_valid
  // linear_velocity_outputs_velocity_1_transmitted_safely
  // resulting_velocity
  rosidl_runtime_c__int16__Sequence__fini(&msg->resulting_velocity);
  // resulting_velocity_flags
  rosidl_runtime_c__boolean__Sequence__fini(&msg->resulting_velocity_flags);
}

sick_safetyscanners2_interfaces__msg__ApplicationOutputs *
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__create()
{
  sick_safetyscanners2_interfaces__msg__ApplicationOutputs * msg = (sick_safetyscanners2_interfaces__msg__ApplicationOutputs *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ApplicationOutputs));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__ApplicationOutputs));
  bool success = sick_safetyscanners2_interfaces__msg__ApplicationOutputs__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__destroy(sick_safetyscanners2_interfaces__msg__ApplicationOutputs * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__init(sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__ApplicationOutputs * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__ApplicationOutputs *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__ApplicationOutputs));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__ApplicationOutputs__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__fini(sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__ApplicationOutputs__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence *
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence * array = (sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__destroy(sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__ApplicationOutputs__Sequence__fini(array);
  }
  free(array);
}
