// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/Field.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/field__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `ranges`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sick_safetyscanners2_interfaces__msg__Field__init(sick_safetyscanners2_interfaces__msg__Field * msg)
{
  if (!msg) {
    return false;
  }
  // ranges
  if (!rosidl_runtime_c__float__Sequence__init(&msg->ranges, 0)) {
    sick_safetyscanners2_interfaces__msg__Field__fini(msg);
    return false;
  }
  // start_angle
  // angular_resolution
  // protective_field
  return true;
}

void
sick_safetyscanners2_interfaces__msg__Field__fini(sick_safetyscanners2_interfaces__msg__Field * msg)
{
  if (!msg) {
    return;
  }
  // ranges
  rosidl_runtime_c__float__Sequence__fini(&msg->ranges);
  // start_angle
  // angular_resolution
  // protective_field
}

sick_safetyscanners2_interfaces__msg__Field *
sick_safetyscanners2_interfaces__msg__Field__create()
{
  sick_safetyscanners2_interfaces__msg__Field * msg = (sick_safetyscanners2_interfaces__msg__Field *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__Field));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__Field));
  bool success = sick_safetyscanners2_interfaces__msg__Field__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__Field__destroy(sick_safetyscanners2_interfaces__msg__Field * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__Field__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__Field__Sequence__init(sick_safetyscanners2_interfaces__msg__Field__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__Field * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__Field *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__Field));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__Field__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__Field__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__Field__Sequence__fini(sick_safetyscanners2_interfaces__msg__Field__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__Field__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__Field__Sequence *
sick_safetyscanners2_interfaces__msg__Field__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__Field__Sequence * array = (sick_safetyscanners2_interfaces__msg__Field__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__Field__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__Field__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__Field__Sequence__destroy(sick_safetyscanners2_interfaces__msg__Field__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__Field__Sequence__fini(array);
  }
  free(array);
}
