// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/RawMicroScanData.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/raw_micro_scan_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "sick_safetyscanners2_interfaces/msg/detail/data_header__functions.h"
// Member `derived_values`
#include "sick_safetyscanners2_interfaces/msg/detail/derived_values__functions.h"
// Member `general_system_state`
#include "sick_safetyscanners2_interfaces/msg/detail/general_system_state__functions.h"
// Member `measurement_data`
#include "sick_safetyscanners2_interfaces/msg/detail/measurement_data__functions.h"
// Member `intrusion_data`
#include "sick_safetyscanners2_interfaces/msg/detail/intrusion_data__functions.h"
// Member `application_data`
#include "sick_safetyscanners2_interfaces/msg/detail/application_data__functions.h"

bool
sick_safetyscanners2_interfaces__msg__RawMicroScanData__init(sick_safetyscanners2_interfaces__msg__RawMicroScanData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!sick_safetyscanners2_interfaces__msg__DataHeader__init(&msg->header)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  // derived_values
  if (!sick_safetyscanners2_interfaces__msg__DerivedValues__init(&msg->derived_values)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  // general_system_state
  if (!sick_safetyscanners2_interfaces__msg__GeneralSystemState__init(&msg->general_system_state)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  // measurement_data
  if (!sick_safetyscanners2_interfaces__msg__MeasurementData__init(&msg->measurement_data)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  // intrusion_data
  if (!sick_safetyscanners2_interfaces__msg__IntrusionData__init(&msg->intrusion_data)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  // application_data
  if (!sick_safetyscanners2_interfaces__msg__ApplicationData__init(&msg->application_data)) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
    return false;
  }
  return true;
}

void
sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(sick_safetyscanners2_interfaces__msg__RawMicroScanData * msg)
{
  if (!msg) {
    return;
  }
  // header
  sick_safetyscanners2_interfaces__msg__DataHeader__fini(&msg->header);
  // derived_values
  sick_safetyscanners2_interfaces__msg__DerivedValues__fini(&msg->derived_values);
  // general_system_state
  sick_safetyscanners2_interfaces__msg__GeneralSystemState__fini(&msg->general_system_state);
  // measurement_data
  sick_safetyscanners2_interfaces__msg__MeasurementData__fini(&msg->measurement_data);
  // intrusion_data
  sick_safetyscanners2_interfaces__msg__IntrusionData__fini(&msg->intrusion_data);
  // application_data
  sick_safetyscanners2_interfaces__msg__ApplicationData__fini(&msg->application_data);
}

sick_safetyscanners2_interfaces__msg__RawMicroScanData *
sick_safetyscanners2_interfaces__msg__RawMicroScanData__create()
{
  sick_safetyscanners2_interfaces__msg__RawMicroScanData * msg = (sick_safetyscanners2_interfaces__msg__RawMicroScanData *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__RawMicroScanData));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__RawMicroScanData));
  bool success = sick_safetyscanners2_interfaces__msg__RawMicroScanData__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__RawMicroScanData__destroy(sick_safetyscanners2_interfaces__msg__RawMicroScanData * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__init(sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__RawMicroScanData * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__RawMicroScanData *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__RawMicroScanData));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__RawMicroScanData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__fini(sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__RawMicroScanData__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence *
sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence * array = (sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__destroy(sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__RawMicroScanData__Sequence__fini(array);
  }
  free(array);
}
