// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/ApplicationInputs.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/application_inputs__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `unsafe_inputs_input_sources`
// Member `unsafe_inputs_flags`
// Member `monitoring_case_number_inputs`
// Member `monitoring_case_number_inputs_flags`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sick_safetyscanners2_interfaces__msg__ApplicationInputs__init(sick_safetyscanners2_interfaces__msg__ApplicationInputs * msg)
{
  if (!msg) {
    return false;
  }
  // unsafe_inputs_input_sources
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->unsafe_inputs_input_sources, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(msg);
    return false;
  }
  // unsafe_inputs_flags
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->unsafe_inputs_flags, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(msg);
    return false;
  }
  // monitoring_case_number_inputs
  if (!rosidl_runtime_c__uint16__Sequence__init(&msg->monitoring_case_number_inputs, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(msg);
    return false;
  }
  // monitoring_case_number_inputs_flags
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->monitoring_case_number_inputs_flags, 0)) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(msg);
    return false;
  }
  // linear_velocity_inputs_velocity_0
  // linear_velocity_inputs_velocity_0_valid
  // linear_velocity_inputs_velocity_0_transmitted_safely
  // linear_velocity_inputs_velocity_1
  // linear_velocity_inputs_velocity_1_valid
  // linear_velocity_inputs_velocity_1_transmitted_safely
  // sleep_mode_input
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(sick_safetyscanners2_interfaces__msg__ApplicationInputs * msg)
{
  if (!msg) {
    return;
  }
  // unsafe_inputs_input_sources
  rosidl_runtime_c__boolean__Sequence__fini(&msg->unsafe_inputs_input_sources);
  // unsafe_inputs_flags
  rosidl_runtime_c__boolean__Sequence__fini(&msg->unsafe_inputs_flags);
  // monitoring_case_number_inputs
  rosidl_runtime_c__uint16__Sequence__fini(&msg->monitoring_case_number_inputs);
  // monitoring_case_number_inputs_flags
  rosidl_runtime_c__boolean__Sequence__fini(&msg->monitoring_case_number_inputs_flags);
  // linear_velocity_inputs_velocity_0
  // linear_velocity_inputs_velocity_0_valid
  // linear_velocity_inputs_velocity_0_transmitted_safely
  // linear_velocity_inputs_velocity_1
  // linear_velocity_inputs_velocity_1_valid
  // linear_velocity_inputs_velocity_1_transmitted_safely
  // sleep_mode_input
}

sick_safetyscanners2_interfaces__msg__ApplicationInputs *
sick_safetyscanners2_interfaces__msg__ApplicationInputs__create()
{
  sick_safetyscanners2_interfaces__msg__ApplicationInputs * msg = (sick_safetyscanners2_interfaces__msg__ApplicationInputs *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ApplicationInputs));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__ApplicationInputs));
  bool success = sick_safetyscanners2_interfaces__msg__ApplicationInputs__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationInputs__destroy(sick_safetyscanners2_interfaces__msg__ApplicationInputs * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__init(sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__ApplicationInputs * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__ApplicationInputs *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__ApplicationInputs));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__ApplicationInputs__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__fini(sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__ApplicationInputs__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence *
sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence * array = (sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__destroy(sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__ApplicationInputs__Sequence__fini(array);
  }
  free(array);
}
