// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sick_safetyscanners2_interfaces:msg/ExtendedLaserScan.idl
// generated code does not contain a copyright notice
#include "sick_safetyscanners2_interfaces/msg/detail/extended_laser_scan__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `laser_scan`
#include "sensor_msgs/msg/detail/laser_scan__functions.h"
// Member `reflektor_status`
// Member `reflektor_median`
// Member `intrusion`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__init(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan * msg)
{
  if (!msg) {
    return false;
  }
  // laser_scan
  if (!sensor_msgs__msg__LaserScan__init(&msg->laser_scan)) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(msg);
    return false;
  }
  // reflektor_status
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->reflektor_status, 0)) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(msg);
    return false;
  }
  // reflektor_median
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->reflektor_median, 0)) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(msg);
    return false;
  }
  // intrusion
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->intrusion, 0)) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(msg);
    return false;
  }
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan * msg)
{
  if (!msg) {
    return;
  }
  // laser_scan
  sensor_msgs__msg__LaserScan__fini(&msg->laser_scan);
  // reflektor_status
  rosidl_runtime_c__boolean__Sequence__fini(&msg->reflektor_status);
  // reflektor_median
  rosidl_runtime_c__boolean__Sequence__fini(&msg->reflektor_median);
  // intrusion
  rosidl_runtime_c__boolean__Sequence__fini(&msg->intrusion);
}

sick_safetyscanners2_interfaces__msg__ExtendedLaserScan *
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__create()
{
  sick_safetyscanners2_interfaces__msg__ExtendedLaserScan * msg = (sick_safetyscanners2_interfaces__msg__ExtendedLaserScan *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan));
  bool success = sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__destroy(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan * msg)
{
  if (msg) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(msg);
  }
  free(msg);
}


bool
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__init(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  sick_safetyscanners2_interfaces__msg__ExtendedLaserScan * data = NULL;
  if (size) {
    data = (sick_safetyscanners2_interfaces__msg__ExtendedLaserScan *)calloc(size, sizeof(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__fini(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence *
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__create(size_t size)
{
  sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence * array = (sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence *)malloc(sizeof(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__destroy(sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence * array)
{
  if (array) {
    sick_safetyscanners2_interfaces__msg__ExtendedLaserScan__Sequence__fini(array);
  }
  free(array);
}
